Package: httptest
Type: Package
Title: A Test Environment for HTTP Requests
Description: Testing and documenting code that communicates with remote servers
    can be painful. Dealing with authentication, server state,
    and other complications can make testing seem too costly to
    bother with. But it doesn't need to be that hard. This package enables one
    to test all of the logic on the R sides of the API in your package without
    requiring access to the remote service. Importantly, it provides three
    contexts that mock the network connection in different ways, as well as
    testing functions to assert that HTTP requests were---or were
    not---made. It also allows one to safely record real API responses to use as
    test fixtures. The ability to save responses and load them offline also
    enables one to write vignettes and other dynamic documents that can be
    distributed without access to a live server.
Version: 4.2.2
Authors@R: c(
        person("Neal", "Richardson", role=c("aut", "cre"), email="neal.p.richardson@gmail.com", comment=c(ORCID="0009-0002-7992-3520")),
        person("Jonathan", "Keane", role="ctb", email="jkeane@gmail.com"),
        person("Maëlle", "Salmon", role="ctb", email="maelle.salmon@yahoo.se", comment=c(ORCID="0000-0002-2815-0399"))
    )
URL: https://enpiar.com/r/httptest/,
        https://github.com/nealrichardson/httptest
BugReports: https://github.com/nealrichardson/httptest/issues
License: MIT + file LICENSE
Depends: R (>= 3.5.0), testthat
Imports: curl, digest, httr, jsonlite, stats, utils
Suggests: knitr, pkgload, rmarkdown, spelling, xml2
Language: en-US
RoxygenNote: 7.2.3
Roxygen: list(markdown = TRUE)
Encoding: UTF-8
VignetteBuilder: knitr
Config/testthat/edition: 3
Config/Needs/coverage: covr
Author: Neal Richardson [aut, cre] (<https://orcid.org/0009-0002-7992-3520>),
  Jonathan Keane [ctb],
  Maëlle Salmon [ctb] (<https://orcid.org/0000-0002-2815-0399>)
Maintainer: Neal Richardson <neal.p.richardson@gmail.com>
Built: R 4.4.0; ; 2024-05-04 15:17:29 UTC; unix

structure(list(
  url = "http://httpbin.org/cookies",
  status_code = 200L,
  headers = structure(list(
    connection = "keep-alive", server = "meinheld/0.6.1",
    date = "Thu, 14 Sep 2017 04:42:04 GMT", `content-type` = "application/json",
    `access-control-allow-origin` = "*", `access-control-allow-credentials` = "true",
    `x-powered-by` = "Flask", `x-processed-time` = "0.000869989395142",
    `content-length` = "44", via = "1.1 vegur"
  ), class = c(
    "insensitive",
    "list"
  )),
  all_headers = list(list(
    status = 302L, version = "HTTP/1.1",
    headers = structure(list(
      connection = "keep-alive", server = "meinheld/0.6.1",
      date = "Thu, 14 Sep 2017 04:42:03 GMT", `content-type` = "text/html; charset=utf-8",
      `content-length` = "223", location = "/cookies",
      `set-cookie` = "token=12345; Path=/", `access-control-allow-origin` = "*",
      `access-control-allow-credentials` = "true", `x-powered-by` = "Flask",
      `x-processed-time` = "0.00116801261902", via = "1.1 vegur"
    ), class = c(
      "insensitive",
      "list"
    ))
  ), list(
    status = 200L, version = "HTTP/1.1",
    headers = structure(list(
      connection = "keep-alive", server = "meinheld/0.6.1",
      date = "Thu, 14 Sep 2017 04:42:04 GMT", `content-type` = "application/json",
      `access-control-allow-origin` = "*", `access-control-allow-credentials` = "true",
      `x-powered-by` = "Flask", `x-processed-time` = "0.000869989395142",
      `content-length` = "44", via = "1.1 vegur"
    ), class = c(
      "insensitive",
      "list"
    ))
  )), cookies = structure(list(
    domain = "httpbin.org",
    flag = FALSE, path = "/", secure = FALSE, expiration = structure(Inf, class = c(
      "POSIXct",
      "POSIXt"
    )), name = "token", value = "12345"
  ), row.names = c(
    NA,
    -1L
  ), class = "data.frame"), content = charToRaw("{\n  \"cookies\": {\n    \"token\": \"12345\"\n  }\n}\n"),
  date = structure(1505364124, class = c("POSIXct", "POSIXt"), tzone = "GMT"), times = c(
    redirect = 0.243357, namelookup = 3.6e-05,
    connect = 3.9e-05, pretransfer = 0.000107, starttransfer = 0.116988,
    total = 0.360433
  ), request = structure(list(
    method = "GET",
    url = "http://httpbin.org/cookies/set?token=12345", headers = c(Accept = "application/json, text/xml, application/xml, */*"),
    fields = NULL, options = list(
      useragent = "libcurl/7.54.0 r-curl/2.8.1 httr/1.3.1",
      httpget = TRUE
    ), auth_token = NULL, output = structure(list(), class = c(
      "write_memory",
      "write_function"
    ))
  ), class = "request")
), class = "response")

structure(list(
  url = "https://example.com/login/",
  status_code = 204L, headers = structure(list(
    allow = "GET, HEAD, OPTIONS, POST",
    `content-type` = "application/json;charset=utf-8", date = "Thu, 14 Sep 2017 04:27:22 GMT",
    server = "nginx", `set-cookie` = "token=12345; Domain=example.com; Max-Age=31536000; Path=/",
    vary = "Cookie, Accept-Encoding", connection = "keep-alive"
  ), class = c(
    "insensitive",
    "list"
  )), all_headers = list(list(
    status = 204L, version = "HTTP/1.1",
    headers = structure(list(
      allow = "GET, HEAD, OPTIONS, POST",
      `content-type` = "application/json;charset=utf-8",
      date = "Thu, 14 Sep 2017 04:27:22 GMT", server = "nginx",
      `set-cookie` = "token=12345; Domain=example.com; Max-Age=31536000; Path=/",
      vary = "Cookie, Accept-Encoding", connection = "keep-alive"
    ), class = c(
      "insensitive",
      "list"
    ))
  )), cookies = structure(list(
    domain = "example.com",
    flag = TRUE, path = "/", secure = FALSE, expiration = structure(1536899241, class = c(
      "POSIXct",
      "POSIXt"
    )), name = "token", value = "12345"
  ), row.names = c(
    NA,
    -1L
  ), class = "data.frame"), content = raw(0), date = structure(1505363242, class = c(
    "POSIXct",
    "POSIXt"
  ), tzone = "GMT"), times = c(
    redirect = 0, namelookup = 0.115726,
    connect = 0.467124, pretransfer = 1.405551, starttransfer = 2.041081,
    total = 2.041137
  ), request = structure(list(
    method = "POST",
    url = "https://example.com/login/", headers = c(
      Accept = "application/json, text/xml, application/xml, */*",
      `Content-Type` = "application/json", `user-agent` = "libcurl/7.54.0 curl/2.8.1 httr/1.3.1"
    ), fields = NULL, options = list(
      useragent = "libcurl/7.54.0 r-curl/2.8.1 httr/1.3.1",
      post = TRUE, postfieldsize = 46L, postfields = charToRaw('{"username":"password"}'), postredir = 3
    ), auth_token = NULL, output = structure(list(), class = c(
      "write_memory",
      "write_function"
    ))
  ), class = "request")
), class = "response")

structure(list(
  url = "http://httpbin.org/cookies", status_code = 200L,
  headers = structure(list(
    connection = "keep-alive", server = "meinheld/0.6.1",
    date = "Thu, 14 Sep 2017 04:34:50 GMT", `content-type` = "application/json",
    `access-control-allow-origin` = "*", `access-control-allow-credentials` = "true",
    `x-powered-by` = "Flask", `x-processed-time` = "0.000942945480347",
    `content-length` = "44", via = "1.1 vegur"
  ), class = c(
    "insensitive",
    "list"
  )), all_headers = list(list(
    status = 200L, version = "HTTP/1.1",
    headers = structure(list(
      connection = "keep-alive", server = "meinheld/0.6.1",
      date = "Thu, 14 Sep 2017 04:34:50 GMT", `content-type` = "application/json",
      `access-control-allow-origin` = "*", `access-control-allow-credentials` = "true",
      `x-powered-by` = "Flask", `x-processed-time` = "0.000942945480347",
      `content-length` = "44", via = "1.1 vegur"
    ), class = c(
      "insensitive",
      "list"
    ))
  )), cookies = structure(list(
    domain = logical(0),
    flag = logical(0), path = logical(0), secure = logical(0),
    expiration = structure(numeric(0), class = c(
      "POSIXct",
      "POSIXt"
    )), name = logical(0), value = logical(0)
  ), row.names = integer(0), class = "data.frame"),
  content = charToRaw("{\n  \"cookies\": {\n    \"token\": \"12345\"\n  }\n}\n"),
  date = structure(1505363690, class = c("POSIXct", "POSIXt"), tzone = "GMT"),
  times = c(
    redirect = 0, namelookup = 0.123097, connect = 0.34047,
    pretransfer = 0.340592, starttransfer = 0.546105, total = 0.546146
  ),
  request = structure(list(
    method = "GET",
    url = "http://httpbin.org/cookies",
    headers = c(Accept = "application/json, text/xml, application/xml, */*"),
    fields = NULL,
    options = list(
      useragent = "libcurl/7.54.0 r-curl/2.8.1 httr/1.3.1",
      cookie = "token=12345",
      httpget = TRUE
    ),
    auth_token = NULL,
    output = structure(list(), class = c(
      "write_memory",
      "write_function"
    ))
  ), class = "request")
), class = "response")

Sys.setlocale("LC_COLLATE", "C") # What CRAN does
set.seed(999)
options(
  warn = 1,
  httptest.debug = FALSE
)

library(httr)

capture_while_mocking <- function(..., path) {
  with_mock_path(path, {
    # We'll write to `path` but read from wherever was set before
    tracer <- quote({
      .mockPaths <- function() getOption("httptest.mock.paths")[-1]
    })
    with_trace("find_mock_file",
      where = with_mock_api, tracer = tracer,
      expr = capture_requests(...)
    )
  })
}

with_redactor <- function(x, ...) {
  old <- getOption("httptest.redactor")
  old.pkgs <- getOption("httptest.redactor.packages")
  set_redactor(x)
  on.exit({
    set_redactor(old)
    options(httptest.redactor.packages = old.pkgs)
  })
  eval.parent(...)
}

reset_redactors <- function() {
  options(
    httptest.redactor = NULL,
    httptest.redactor.packages = NULL,
    httptest.requester = NULL,
    httptest.requester.packages = NULL
  )
}

install_testpkg <- function(pkg, lib = tempfile()) {
  dir.create(lib)
  tools::Rcmd(c("INSTALL", "testpkg", paste0("--library=", shQuote(lib))),
    stdout = NULL, stderr = NULL
  )
  return(lib)
}

# A quiet version of httr's content
quiet_content <- function(...) {
  suppressMessages(content(...))
}

testthat_transition <- function(old, new) {
  is_3e <- tryCatch(testthat::edition_get() == 3, error = function(e) FALSE)
  if (is_3e) {
    eval(new, envir = parent.frame())
  } else {
    eval(old, envir = parent.frame())
  }
}

# assign to global to be used inside of `public()` calls
third_edition <<- tryCatch(testthat::edition_get() == 3, error = function(e) FALSE)

d <- tempfile()
dl_file <- tempfile()
webp_file <- tempfile()

test_that("We can record a series of requests (a few ways)", {
  skip_if_disconnected()
  skip_on_ci()
  capture_requests(path = d, {
    # <<- assign these so that they're available in the next test_that too
    r1 <<- GET("http://httpbin.org/get")
    r2 <<- GET("http://httpbin.org")
    r3 <<- GET("http://httpbin.org/status/418")
    r4 <<- PUT("http://httpbin.org/put")
  })
  start_capturing(path = d)
  r5 <<- GET("http://httpbin.org/response-headers",
    query = list(`Content-Type` = "application/json")
  )
  r6 <<- GET("http://httpbin.org/anything", config = write_disk(dl_file))
  r7 <<- GET("http://httpbin.org/image/webp", config = write_disk(webp_file))
  r8 <<- RETRY("GET", "http://httpbin.org/status/202")
  stop_capturing()
  .mockPaths(NULL) # because start_capturing with path modifies global state
  expect_identical(
    sort(dir(d, recursive = TRUE)),
    c(
      "httpbin.org.html", # it's HTML, and we now support that simplified
      "httpbin.org/anything.json",
      "httpbin.org/get.json",
      "httpbin.org/image/webp.R", # Not a simplifiable format, so .R
      "httpbin.org/image/webp.R-FILE", # The `write_disk` location
      "httpbin.org/put-PUT.json", # Not a GET, but returns 200
      "httpbin.org/response-headers-ac4928.json",
      "httpbin.org/status/202.R", # Not 200 response, so .R
      "httpbin.org/status/418.R" # Not 200 response, so .R
    )
  )
  # Test the contents of the .R files
  teapot <- source(file.path(d, "httpbin.org/status/418.R"))$value
  expect_s3_class(teapot, "response")
  expect_identical(teapot$status_code, 418L)
  # Make sure that our .html file has HTML
  expect_true(any(grepl(
    "</body>",
    suppressWarnings(readLines(file.path(d, "httpbin.org.html")))
  )))
})

test_that("We can then load the mocks it stores", {
  skip_if_disconnected()
  skip_on_ci()
  # Look for mocks in our temp dir
  with_mock_path(d, {
    # Because the place we wrote out the file in our real request might not
    # naturally be in our mock directory, assume that that file doesn't exist
    # when we load our mocks.
    content_r6 <<- content(r6)
    file.remove(dl_file)
    content_r7 <<- content(r7)
    file.remove(webp_file)

    mock_dl_file <- tempfile()
    mock_webp_file <- tempfile()
    with_mock_api({
      m1 <- GET("http://httpbin.org/get")
      m2 <- GET("http://httpbin.org")
      m3 <- GET("http://httpbin.org/status/418")
      m4 <- PUT("http://httpbin.org/put")
      m5 <- GET("http://httpbin.org/response-headers",
        query = list(`Content-Type` = "application/json")
      )
      m6 <- GET("http://httpbin.org/anything", config = write_disk(mock_dl_file))
      m7 <- GET("http://httpbin.org/image/webp", config = write_disk(mock_webp_file))
      m8 <- RETRY("GET", "http://httpbin.org/status/202")
    })
  })
  expect_identical(content(m1), content(r1))
  # Compare the HTML as text because the parsed HTML (XML) object has a
  # C pointer that is different between the two objects.
  expect_identical(
    enc2native(quiet_content(m2, "text")),
    enc2native(content(r2, "text"))
  )

  expect_true(grepl("</body>", quiet_content(m2, "text")))
  expect_identical(content(m3), content(r3))
  expect_identical(content(m4), content(r4))
  expect_identical(content(m5), content(r5))
  expect_identical(content(m6), content_r6)
  expect_identical(content(m7), content_r7)
  expect_equal(m8$status_code, 202)
})

test_that("write_disk mocks can be reloaded even if the mock directory moves", {
  skip_if_disconnected()
  skip_on_ci()
  # This is an edge case caught because `crunch` package puts fixtures in
  # `inst/`, so you record to one place but when you read them from the
  # installed package, it's a different directory.
  d2 <- tempfile()
  dir.create(file.path(d2, "httpbin.org", "image"), recursive = TRUE)
  for (f in c("httpbin.org/image/webp.R", "httpbin.org/image/webp.R-FILE")) {
    file.rename(file.path(d, f), file.path(d2, f))
  }
  with_mock_path(d2, {
    with_mock_api({
      m7b <- GET("http://httpbin.org/image/webp",
        config = write_disk(tempfile())
      )
    })
  })
  expect_identical(content(m7b), content_r7)
})

with_mock_api({
  d2 <- tempfile()
  test_that("Recording requests even with the mock API", {
    capture_while_mocking(path = d2, {
      GET("http://example.com/get/")
      GET("api/object1/")
      GET("http://httpbin.org/status/204/")
    })
    expect_true(setequal(
      dir(d2, recursive = TRUE),
      c("example.com/get.json", "api/object1.json", "httpbin.org/status/204.204")
    ))
    expect_identical(
      readLines(file.path(d2, "example.com/get.json")),
      readLines("example.com/get.json")
    )
  })

  test_that("Loading 204 response status recorded with simplify=TRUE", {
    original <- GET("http://httpbin.org/status/204/")
    expect_null(content(original))
    expect_length(
      readLines(file.path(d2, "httpbin.org/status/204.204")),
      0
    )
    with_mock_path(d2,
      {
        mocked <- GET("http://httpbin.org/status/204/")
        expect_null(content(mocked))
      },
      replace = TRUE
    )
  })

  d3 <- tempfile()
  test_that("Using simplify=FALSE (and setting .mockPaths)", {
    with_mock_path(d3, {
      capture_while_mocking(simplify = FALSE, {
        GET("http://example.com/get/")
        GET("api/object1/")
        GET("http://httpbin.org/status/204/")
      })
    })
    expect_true(setequal(
      dir(d3, recursive = TRUE),
      c("example.com/get.R", "api/object1.R", "httpbin.org/status/204.R")
    ))
    response <- source(file.path(d3, "example.com/get.R"))$value
    expect_s3_class(response, "response")
    expect_identical(
      content(response),
      content(GET("http://example.com/get/"))
    )
  })

  test_that("Recorded JSON is prettified", {
    expect_length(
      readLines(file.path(d2, "example.com/get.json")),
      3L
    )
    skip("TODO: prettify when simplify=FALSE")
    response <- readLines(file.path(d3, "api/object1.R"))
  })

  test_that("Using options(httptest.verbose = TRUE) works", {
    d4 <- tempfile()
    old <- options(httptest.verbose = TRUE)
    on.exit(options(old))
    with_mock_path(d4, {
      capture_while_mocking(
        expect_message(
          GET("http://example.com/get/"),
          "Writing .*example.com.get.json"
        )
      )
    })
    expect_true(setequal(
      dir(d4, recursive = TRUE),
      c("example.com/get.json")
    ))
    expect_identical(
      readLines(file.path(d4, "example.com/get.json")),
      readLines("example.com/get.json")
    )
  })

  test_that("Request object isn't recorded at all", {
    d5 <- tempfile()
    with_mock_path(d5, {
      capture_while_mocking(
        {
          POST("http://example.com/login",
            body = list(username = "password"),
            encode = "json"
          )
        },
        simplify = FALSE
      )
      no_payload <- source(file.path(
        d5,
        "example.com", "login-712027-POST.R"
      ))$value
      expect_null(no_payload$request)
      with_mock_api({
        reloaded <- POST("http://example.com/login",
          body = list(username = "password"),
          encode = "json"
        )
      })
      expect_identical(
        rawToChar(reloaded$request$options[["postfields"]]),
        '{"username":"password"}'
      )
    })
  })
})

test_that("If the httr request function exits with an error, capture_requests warns", {
  capture_requests({
    expect_warning(
      expect_error(GET(stop("Error!"))),
      "Request errored; no captured response file saved"
    )
  })
})

public({
  test_that("with_mock_dir works when the directory with mock files exists", {
    temporary_dir <- tempfile()
    # The directory exists, so we'll read mocks from it
    dir.create(temporary_dir)
    # Put mocks in it
    file.copy(testthat::test_path("httpbin.org"), temporary_dir, recursive = TRUE)

    current_mock_paths <- .mockPaths()
    with_mock_dir(temporary_dir, {
      # There's nothing on the mock paths other than our mock dir
      expect_identical(.mockPaths(), temporary_dir)
      expect_no_request(resp <- GET("http://httpbin.org/status/204"))
      # We've read from the mock
      expect_equal(headers(resp)$date, "Sat, 24 Feb 2018 00:22:11 GMT")
    })
    # Original mock paths are reset
    expect_true(all.equal(current_mock_paths, .mockPaths()))
  })

  test_that("with_mock_dir creates mock files directory", {
    skip_if_disconnected()
    skip_on_ci()
    temporary_dir <- tempfile()
    current_mock_paths <- .mockPaths()
    with_mock_dir(temporary_dir, {
      # Since the directory doesn't exist, we will create it and capture
      expect_identical(.mockPaths(), temporary_dir)
      # The first one makes the request
      resp <- GET("http://httpbin.org/status/204")
      # And it's a real request, not using our fixture
      expect_false(headers(resp)$date == "Sat, 24 Feb 2018 00:22:11 GMT")
    })
    expect_true(all.equal(current_mock_paths, .mockPaths()))
  })

  test_that("with_mock_dir prefers to be in tests/testthat", {
    d <- tempfile()
    dir.create(file.path(d, "tests", "testthat"), recursive = TRUE)
    old <- setwd(d)
    on.exit(setwd(old))

    with_mock_dir("asdf", {
      expect_identical(.mockPaths(), file.path("tests", "testthat", "asdf"))
    })
    with_mock_dir("/asdf", {
      expect_identical(.mockPaths(), "/asdf")
    })
  })

  test_that("with_mock_dir uses the set requester", {
    set_requester(function (request) {
      gsub_request(
        request,
        "http://httpbin.org/status/",
        "api/",
        fixed = TRUE
      )
    })
    d <- tempfile()
    dir.create(file.path(d, "tests", "testthat"), recursive = TRUE)
    old <- setwd(d)
    on.exit(setwd(old))

    with_mock_dir("asdf", {
      resp <- GET("http://httpbin.org/status/204")
      expect_true(dir.exists(file.path("tests", "testthat", "asdf", "api")))
    })
  })
})

expect_redactor <- function(expr) {
  expect_identical(names(formals(expr)), "response")
}

test_that("prepare_redactor: function", {
  expect_identical(prepare_redactor(redact_cookies), redact_cookies)
})

multiredact <- list(redact_cookies, ~ redact_headers(., "X-Header"))
test_that("prepare_redactor: list/multiple", {
  expect_redactor(prepare_redactor(multiredact))
  expect_identical(prepare_redactor(multiredact[1]), redact_cookies)
})

test_that("prepare_redactor: NULL for no redacting", {
  expect_identical(prepare_redactor(NULL), force)
})

test_that("prepare_redactor: garbage", {
  expect_error(
    prepare_redactor("foo"),
    "Redactor must be a function or list of functions"
  )
})

test_that("get_current_redactor edge cases", {
  options(httptest.redactor = NULL)
  expect_identical(get_current_redactor(), redact_auth)
  options(httptest.redactor.packages = "NOTAPACKAGE")
  expect_identical(get_current_redactor(), redact_auth)
})

with_mock_api({
  test_that("Reading redactors from within a package (and install that package)", {
    newmocks <- tempfile()
    testthat_transition(
      expect_message(
        capture_while_mocking(path = newmocks, {
          # Install the "testpkg" to a temp lib.loc _after_ we've
          # already started recording
          lib <- install_testpkg("testpkg")
          library(testpkg, lib.loc = lib)
          expect_true("testpkg" %in% names(sessionInfo()$otherPkgs))

          r <- GET("http://example.com/get")
        }),
        paste0("Using redact.R from ", dQuote("testpkg"))
      ),
      expect_message(
        expect_message(
          capture_while_mocking(path = newmocks, {
            # Install the "testpkg" to a temp lib.loc _after_ we've
            # already started recording
            lib <- install_testpkg("testpkg")
            library(testpkg, lib.loc = lib)
            expect_true("testpkg" %in% names(sessionInfo()$otherPkgs))
            r <- GET("http://example.com/get")
          }),
          paste0("Using redact.R from ", dQuote("testpkg"))
        ),
        paste0("Using request.R from ", dQuote("testpkg"))
      )
    )
    with_mock_path(newmocks, {
      r2 <- GET("http://example.com/get")
    })
    # The resulting mock content is what we injected into it from testpkg
    expect_identical(content(r2), list(fake = TRUE))
  })

  test_that("Request preprocessing via package inst/httptest/request.R", {
    # That function prunes a leading http://pythong.org/ from URLs
    expect_identical(
      content(GET("http://pythong.org/api/object1/")),
      content(GET("api/object1/"))
    )
  })

  test_that("set_redactor(NULL) to override default (and loaded packages)", {
    expect_true("testpkg" %in% names(sessionInfo()$otherPkgs))
    # Great, but let's kill it when we're done
    on.exit(detach("package:testpkg", unload = TRUE))
    newmocks2 <- tempfile()
    with_redactor(
      NULL,
      capture_while_mocking(simplify = FALSE, path = newmocks2, {
        a <- POST("http://example.com/login",
          body = list(username = "password"), encode = "json"
        )
      })
    )
    # The auth token, which would have been removed (see test-redact.R),
    # is present in the file we wrote because we set NULL as redactor
    expect_true(any(grepl(
      "token=12345",
      readLines(file.path(newmocks2, "example.com", "login-712027-POST.R"))
    )))
  })

  test_that("Loading a package with pkgload (devtools)", {
    newmocks3 <- tempfile()
    expect_false("testpkg" %in% names(sessionInfo()$otherPkgs))
    on.exit(pkgload::unload("testpkg"))
    expect_message(
      capture_while_mocking(path = newmocks3, {
        pkgload::load_all("testpkg", quiet = TRUE)
        expect_true("testpkg" %in% names(sessionInfo()$otherPkgs))
        r <- GET("http://example.com/get")
      }),
      paste0("Using redact.R from ", dQuote("testpkg"))
    )
    with_mock_path(newmocks3, {
      r2 <- GET("http://example.com/get")
    })
    # The resulting mock content is what we injected into it from testpkg
    expect_identical(content(r2), list(fake = TRUE))
  })
})

reset_redactors()

d <- tempfile()

with_mock_api({
  # Auth headers aren't recorded
  capture_while_mocking(simplify = FALSE, path = d, {
    a <- GET("api/", add_headers(`Authorization` = "Bearer token"))
  })
  test_that("The response has the real request header", {
    expect_equal(a$request$headers[["Authorization"]], "Bearer token")
  })
  test_that("But the mock file does not", {
    expect_false(any(grepl("Bearer token", readLines(file.path(d, "api.R")))))
  })
  test_that("And the redacted .R mock can be loaded", {
    with_mock_path(d, {
      b <- GET("api/", add_headers(`Authorization` = "Bearer token"))
    })
    expect_equal(content(b), content(a))
  })

  # Request cookies aren't recorded
  capture_while_mocking(simplify = FALSE, path = d, {
    cooks <- GET("http://httpbin.org/cookies", set_cookies(token = "12345"))
  })
  test_that("redact_cookies: the response has the cookie set in the request", {
    expect_identical(cooks$request$options$cookie, "token=12345")
  })
  test_that("redact_cookies removes cookies from request in the mock file", {
    cooksfile <- readLines(file.path(d, "httpbin.org", "cookies.R"))
    expect_false(any(grepl("token=12345", cooksfile)))
  })
  test_that("And the redacted .R mock can be loaded", {
    with_mock_path(d, {
      cooksb <- GET("http://httpbin.org/cookies", set_cookies(token = "12345"))
    })
    expect_equal(content(cooksb), content(cooks))
  })

  # redact_cookies from response
  capture_while_mocking(simplify = FALSE, path = d, {
    c2 <- GET("http://httpbin.org/cookies/set", query = list(token = 12345))
  })
  test_that("redact_cookies: the response has the set-cookie in the response", {
    # Note the "all_headers": the request did a 302 redirect
    expect_identical(
      c2$all_headers[[1]]$headers[["set-cookie"]],
      "token=12345; Path=/"
    )
    expect_identical(c2$cookies$value, "12345")
  })
  test_that("redact_cookies removes set-cookies from response in the mock file", {
    # Note that "token=12345" appears in the request URL because of how
    # httpbin works. But normally your cookie wouldn't be in the URL.
    # Of course, if you wanted to sanitize URLs too, you could write your
    # own custom redacting function.
    expect_false(any(grepl(
      '"token=12345',
      readLines(file.path(d, "httpbin.org", "cookies", "set-5b2631.R"))
    )))
    expect_length(
      grep(
        "REDACTED",
        readLines(file.path(d, "httpbin.org", "cookies", "set-5b2631.R"))
      ),
      2
    )
  })
  test_that("And when loading that .R mock, the redacted value doesn't appear", {
    with_mock_path(d, {
      c2b <- GET("http://httpbin.org/cookies/set", query = list(token = 12345))
    })
    expect_identical(
      c2b$all_headers[[1]]$headers[["set-cookie"]],
      "REDACTED"
    )
    expect_identical(c2b$cookies$value, "REDACTED")
  })

  # another redact_cookies with POST example.com/login
  capture_while_mocking(simplify = FALSE, path = d, {
    login <- POST("http://example.com/login",
      body = list(username = "password"), encode = "json"
    )
  })
  test_that("redact_cookies: the response has the set-cookie in the response", {
    # Note the "all_headers": the request did a 302 redirect
    expect_true(grepl(
      "token=12345",
      login$all_headers[[1]]$headers[["set-cookie"]]
    ))
    expect_true(grepl(
      "token=12345",
      login$headers[["set-cookie"]]
    ))
    expect_identical(login$cookies$value, "12345")
  })
  test_that("redact_cookies removes set-cookies from response in the mock file", {
    # Unlike other example, token=12345 isn't in the URL
    expect_false(any(grepl(
      "12345",
      readLines(file.path(d, "example.com", "login-712027-POST.R"))
    )))
    expect_length(
      grep(
        "REDACTED",
        readLines(file.path(d, "example.com", "login-712027-POST.R"))
      ),
      3
    )
  })
  test_that("And when loading that .R mock, the redacted value doesn't appear", {
    with_mock_path(d, {
      loginb <- POST("http://example.com/login",
        body = list(username = "password"), encode = "json"
      )
    })
    expect_identical(
      loginb$all_headers[[1]]$headers[["set-cookie"]],
      "REDACTED"
    )
    expect_identical(loginb$headers[["set-cookie"]], "REDACTED")
    expect_identical(loginb$cookies$value, "REDACTED")
  })

  # HTTP auth credentials aren't recorded
  capture_while_mocking(simplify = FALSE, path = d, {
    pwauth <- GET(
      "http://httpbin.org/basic-auth/user/passwd",
      authenticate("user", "passwd")
    )
  })
  test_that("redact_http_auth: the request has the user:pw set", {
    expect_identical(pwauth$request$options$userpwd, "user:passwd")
  })
  test_that("redact_http_auth removes user:pw from request in the mock file", {
    expect_false(any(grepl(
      "user:passwd",
      readLines(file.path(d, "httpbin.org", "basic-auth", "user", "passwd.R"))
    )))
  })
  test_that("And the redacted .R mock can be loaded", {
    with_mock_path(d, {
      pwauthb <- GET(
        "http://httpbin.org/basic-auth/user/passwd",
        authenticate("user", "passwd")
      )
    })
    expect_equal(content(pwauthb), content(pwauth))
  })

  # OAuth credentials aren't recorded
  # Example token copied from a test in httr
  token <- Token2.0$new(
    app = oauth_app("x", "y", "z"),
    endpoint = oauth_endpoints("google"),
    credentials = list(access_token = "ofNoArms")
  )
  token$params$as_header <- TRUE
  capture_while_mocking(simplify = FALSE, path = d, {
    oauth <- GET("api/object1/", config(token = token))
  })
  test_that("The response has the 'auth_token' object'", {
    expect_s3_class(oauth$request$auth_token, "Token2.0")
  })

  test_that("But the mock doesn't have the auth_token", {
    oauthfile <- readLines(file.path(d, "api", "object1.R"))
    expect_false(any(grepl("auth_token", oauthfile)))
  })
  test_that("And the .R mock can be loaded", {
    with_mock_path(d, {
      oauthb <- GET("api/object1/", config(token = token))
    })
    expect_equal(content(oauthb), content(oauth))
  })

  # Custom redacting function
  my_redactor <- function(response) {
    # Proof that you can alter other parts of the response/mock
    response$url <- response$request$url <- "http://example.com/fakeurl"
    # Proof that you can alter the response body
    cleaner <- function(x) gsub("loaded", "changed", x)
    response <- within_body_text(response, cleaner)
    return(response)
  }
  with_redactor(
    my_redactor,
    capture_while_mocking(simplify = FALSE, path = d, {
      r <- GET("http://example.com/get")
    })
  )
  test_that("The real request is not affected by the redactor", {
    expect_identical(r$url, "http://example.com/get")
    expect_identical(content(r), list(loaded = TRUE))
  })
  test_that("But the mock file gets written to the modified path with altered content", {
    # Use replace=TRUE to make sure that "." isn't in the search path.
    # We're checking that the original request doesn't have a mock,
    # but of course we made it from a mock in the working directory
    with_mock_path(d, replace = TRUE, {
      expect_GET(
        GET("http://example.com/get"),
        "http://example.com/get"
      )
      expect_error(alt <- GET("http://example.com/fakeurl"), NA)
      expect_identical(content(alt), list(changed = TRUE))
    })
  })

  a <- GET("api/", add_headers(`Authorization` = "Bearer token"))
  test_that("gsub_response", {
    asub <- gsub_response(a, "api", "OTHER")
    expect_identical(asub$url, "OTHER/")
    expect_identical(content(asub), list(value = "OTHER/object1/"))
  })
  test_that("as.redactor", {
    a2 <- prepare_redactor(~ gsub_response(., "api", "OTHER"))(a)
    expect_identical(content(a2), list(value = "OTHER/object1/"))
  })

  loc <- GET("http://httpbin.org/response-headers",
    query = list(Location = "http://httpbin.org/status/201")
  )
  loc_sub <- gsub_response(
    loc, "http://httpbin.org/status/201",
    "http://httpbin.org/status/404"
  )
  test_that("gsub_response touches Location header", {
    expect_identical(
      loc_sub$headers$location,
      "http://httpbin.org/status/404"
    )
    expect_identical(
      loc_sub$all_headers[[1]]$headers$location,
      "http://httpbin.org/status/404"
    )
    expect_identical(
      content(loc_sub)$Location,
      "http://httpbin.org/status/404"
    )
  })
  test_that("gsub_response handles URL encoding", {
    skip("TODO: handle URL escaping")
    expect_identical(
      loc_sub$url,
      "http://httpbin.org/response-headers?Location=http%3A%2F%2Fhttpbin.org%2Fstatus%2F404"
    )
  })
})


with_fake_http({
  expect_PUT(
    p <- PUT("http://httpbin.org/put",
      body = list(x = "A string", string = "Something else")
    )
  )
  req <- p$request
  # TODO: more gsub_request tests
  test_that("gsub_request on non-JSON post fields", {
    expect_identical(
      gsub_request(req, "string", "SECRET")$fields,
      list(x = "A SECRET", SECRET = "Something else")
    )
  })
})

test_that("chain_redactors", {
  f1 <- function(x) x * 4
  f2 <- ~ sum(c(., 3))
  f12 <- chain_redactors(list(f1, f2))
  f21 <- chain_redactors(list(f2, f1))
  expect_equal(f12(5), 23)
  expect_equal(f21(5), 32)
})

reset_redactors()

rp <- httr:::request_perform
g <- httr::GET
path <- tempfile()

test_that("start/end_vignette with recording (dir does not exist yet)", {
  start_vignette(path)
  expect_true(identical(rp, httr:::request_perform))
  expect_false(identical(g, httr::GET))
  expect_identical(.mockPaths()[1], file.path(path, "0"))
  # Test that state_change bumps the mockPath
  change_state()
  expect_identical(.mockPaths()[1], file.path(path, "1"))
  expect_identical(.mockPaths()[2], file.path(path, "0"))
  end_vignette()
  expect_true(identical(rp, httr:::request_perform))
  expect_true(identical(g, httr::GET))
  expect_false(any(grepl(path, .mockPaths()[1], fixed = TRUE)))
})

test_that("start/end_vignette with mocking (dir exists)", {
  on.exit(options(httptest.verbose = NULL))
  dir.create(path)
  start_vignette(path)
  expect_false(identical(rp, httr:::request_perform))
  expect_true(identical(g, httr::GET))
  end_vignette()
  expect_true(identical(rp, httr:::request_perform))
  expect_true(identical(g, httr::GET))
})

test_that("start_vignette puts path in vignettes dir, if exists", {
  d <- tempfile()
  dir.create(file.path(d, "vignettes"), recursive = TRUE)
  old <- setwd(d)
  on.exit(setwd(old))

  start_vignette("testing")
  expect_identical(.mockPaths()[1], file.path("vignettes", "testing", "0"))
  end_vignette()
})

test_that("start/end_vignette calls inst/httptest/vignette-start/end.R", {
  lib <- install_testpkg("testpkg")
  library(testpkg, lib.loc = lib)
  on.exit(detach("package:testpkg", unload = TRUE))
  expect_false(getOption("testpkg.start.vignette", FALSE))
  start_vignette(path)
  expect_true(getOption("testpkg.start.vignette"))

  end_vignette()
  expect_false(getOption("testpkg.start.vignette", FALSE))
})

test_that("change_state validation", {
  with_mock_path("foo", {
    expect_error(change_state(), "foo is not valid for change_state()")
  })
})

reset_redactors()

test_add_to_desc <- function(str, msg = "Adding 'httptest' to Suggests") {
  f <- tempfile()
  cat(str, file = f)
  expect_message(add_httptest_to_desc(f), msg)
  setNames(read.dcf(f, keep.white = "Suggests")[, "Suggests"], NULL)
}

test_that("add to desc adds Suggests if not present", {
  expect_identical(test_add_to_desc("Title: Foo"), "httptest")
})

test_that("add to desc adds Suggests if present but empty", {
  expect_identical(test_add_to_desc("Suggests:"), "httptest")
})

test_that("add to desc adds Suggests inline", {
  expect_identical(test_add_to_desc("Suggests: pkg"), "httptest, pkg")
  expect_identical(
    test_add_to_desc("Suggests: pkg, alpha (>= 2.0.0)"),
    "alpha (>= 2.0.0), httptest, pkg"
  )
})

desc_suggests_one_multiline <- "Title: Foo
Suggests:
    pkg
"
desc_suggests_two_multiline <- "Title: Foo
Suggests:
    pkg,
    alpha (>= 2.0.0)
"
desc_suggests_two_uneven <- "Title: Foo
Suggests: pkg,
    alpha (>= 2.0.0)
"

test_that("add to desc adds Suggests multiline", {
  expect_identical(
    test_add_to_desc(desc_suggests_one_multiline),
    "\n    httptest,\n    pkg"
  )
  expect_identical(
    test_add_to_desc(desc_suggests_two_multiline),
    "\n    alpha (>= 2.0.0),\n    httptest,\n    pkg"
  )
  expect_identical(
    test_add_to_desc(desc_suggests_two_uneven),
    "alpha (>= 2.0.0),\n    httptest,\n    pkg"
  )
})

test_that("add to desc doesn't add if already present", {
  expect_identical(test_add_to_desc("Suggests: httptest", msg = NA), "httptest")
  expect_identical(
    test_add_to_desc("Suggests: pkg, httptest", msg = NA),
    "pkg, httptest"
  )
})

expect_added_to_setup <- function(str, msg = "Adding library\\(httptest\\)") {
  f <- tempfile()
  cat(str, file = f)
  expect_message(add_httptest_to_setup(f), msg)
  expect_true(any(grepl("library(httptest)", readLines(f), fixed = TRUE)))
}

test_that("add to setup creates file if doesn't exist", {
  f <- tempfile()
  expect_false(file.exists(f))
  testthat_transition(
    expect_message(add_httptest_to_setup(f), "Creating"),
    expect_message(
      expect_message(add_httptest_to_setup(f), "Creating"),
      "Adding library\\(httptest\\) to"
    )
  )
  expect_identical(readLines(f), "library(httptest)")
})

test_that("add to setup adds", {
  expect_added_to_setup("")
  expect_added_to_setup("library(pkg)\n")
})

test_that("add to setup doesn't duplicate", {
  expect_added_to_setup("library(httptest)\n", msg = NA)
})

test_that("use_httptest integration test", {
  testpkg <- tempfile()
  dir.create(testpkg)
  expect_error(use_httptest(testpkg), "is not an R package directory")

  desc <- file.path(testpkg, "DESCRIPTION")
  cat("Title: Foo\n", file = desc)
  setup <- file.path(testpkg, "tests", "testthat", "setup.R")
  testthat_transition(
    expect_message(use_httptest(testpkg), "Adding 'httptest' to Suggests"),
    expect_message(
      expect_message(
        expect_message(
          use_httptest(testpkg),
          "Adding 'httptest' to Suggests"
        ),
        "Creating "
      ),
      "Adding library\\(httptest\\) to "
    )
  )
  expect_identical(readLines(desc), c("Title: Foo", "Suggests: httptest"))
  expect_identical(readLines(setup), "library(httptest)")
  # It does nothing if you the package already uses httptest
  expect_message(use_httptest(testpkg), NA)
})

public({
  test_that(".mockPaths works more or less like .libPaths", {
    expect_identical(.mockPaths(), ".")
    .mockPaths("something else")
    expect_identical(.mockPaths(), c("something else", "."))
    # Unique paths
    .mockPaths(".")
    expect_identical(.mockPaths(), c(".", "something else"))
    .mockPaths(NULL)
    expect_identical(.mockPaths(), ".")
  })

  test_that(".mockPaths default path prefers to be in tests/testthat", {
    d <- tempfile()
    dir.create(file.path(d, "tests", "testthat"), recursive = TRUE)
    old <- setwd(d)
    on.exit(setwd(old))

    expect_identical(.mockPaths(), "tests/testthat")
  })

  with_mock_api({
    test_that("GET with no query, default mock path", {
      b <- GET("api/object1/")
      expect_identical(content(b), list(object = TRUE))
    })
    test_that("GET with query, default mock path", {
      obj <- GET("api/object1/", query = list(a = 1))
      expect_json_equivalent(
        content(obj),
        list(query = list(a = 1), mocked = "yes")
      )
    })
    test_that("There is no api/object2/ mock", {
      expect_GET(GET("api/object2/"))
    })

    .mockPaths("alt")
    test_that("GET with query, different mock path", {
      obj <- GET("api/object1/", query = list(a = 1))
      expect_json_equivalent(
        content(obj),
        list(query = list(a = 1), mocked = "twice")
      )
    })
    test_that("Now there is an api/object2/ mock", {
      obj <- GET("api/object2/")
      expect_identical(content(obj), list(object2 = TRUE))
    })
    test_that("If the primary mock dir doesn't have a mock, it passes to next", {
      b <- GET("api/object1/")
      expect_identical(content(b), list(object = TRUE))
    })
    test_that("Failure to find a mock in any dir", {
      expect_GET(GET("api/NOTAFILE/"))
    })

    .mockPaths(NULL)
    test_that("NULL mockPaths resets to default", {
      obj <- GET("api/object1/", query = list(a = 1))
      expect_json_equivalent(
        content(obj),
        list(query = list(a = 1), mocked = "yes")
      )
      expect_GET(GET("api/object2/"))
    })
  })
})

structure(list(
  url = "http://httpbin.org/status/204", status_code = 204L,
  headers = structure(list(
    `content-length` = "0", connection = "keep-alive",
    server = "meinheld/0.6.1", date = "Sat, 24 Feb 2018 00:22:11 GMT",
    `content-type` = "text/html; charset=utf-8", `access-control-allow-origin` = "*",
    `access-control-allow-credentials` = "true", `x-powered-by` = "Flask",
    `x-processed-time` = "0", via = "1.1 vegur"
  ), .Names = c(
    "content-length",
    "connection", "server", "date", "content-type", "access-control-allow-origin",
    "access-control-allow-credentials", "x-powered-by", "x-processed-time",
    "via"
  ), class = c("insensitive", "list")), all_headers = list(
    structure(list(status = 204L, version = "HTTP/1.1", headers = structure(list(
      `content-length` = "0", connection = "keep-alive",
      server = "meinheld/0.6.1", date = "Sat, 24 Feb 2018 00:22:11 GMT",
      `content-type` = "text/html; charset=utf-8", `access-control-allow-origin` = "*",
      `access-control-allow-credentials` = "true", `x-powered-by` = "Flask",
      `x-processed-time` = "0", via = "1.1 vegur"
    ), .Names = c(
      "content-length",
      "connection", "server", "date", "content-type", "access-control-allow-origin",
      "access-control-allow-credentials", "x-powered-by", "x-processed-time",
      "via"
    ), class = c("insensitive", "list"))), .Names = c(
      "status",
      "version", "headers"
    ))
  ), cookies = structure(list(
    domain = logical(0),
    flag = logical(0), path = logical(0), secure = logical(0),
    expiration = structure(numeric(0), class = c(
      "POSIXct",
      "POSIXt"
    )), name = logical(0), value = logical(0)
  ), .Names = c(
    "domain",
    "flag", "path", "secure", "expiration", "name", "value"
  ), row.names = integer(0), class = "data.frame"),
  content = charToRaw(""), date = structure(1519431731, class = c(
    "POSIXct",
    "POSIXt"
  ), tzone = "GMT"), times = structure(c(
    0, 4.5e-05,
    4.8e-05, 0.000105, 0.100235, 0.100262
  ), .Names = c(
    "redirect",
    "namelookup", "connect", "pretransfer", "starttransfer",
    "total"
  ))
), .Names = c(
  "url", "status_code", "headers", "all_headers",
  "cookies", "content", "date", "times"
), class = "response")

structure(list(
  url = "http://httpbin.org/response-headers?Location=http%3A%2F%2Fhttpbin.org%2Fstatus%2F201",
  status_code = 200L, headers = structure(list(
    connection = "keep-alive",
    server = "meinheld/0.6.1", date = "Sat, 24 Feb 2018 00:22:10 GMT",
    `content-type` = "application/json", location = "http://httpbin.org/status/201",
    `access-control-allow-origin` = "*", `access-control-allow-credentials` = "true",
    `x-powered-by` = "Flask", `x-processed-time` = "0", `content-length` = "89",
    via = "1.1 vegur"
  ), .Names = c(
    "connection", "server",
    "date", "content-type", "location", "access-control-allow-origin",
    "access-control-allow-credentials", "x-powered-by", "x-processed-time",
    "content-length", "via"
  ), class = c("insensitive", "list")), all_headers = list(structure(list(
    status = 200L, version = "HTTP/1.1",
    headers = structure(list(
      connection = "keep-alive", server = "meinheld/0.6.1",
      date = "Sat, 24 Feb 2018 00:22:10 GMT", `content-type` = "application/json",
      location = "http://httpbin.org/status/201", `access-control-allow-origin` = "*",
      `access-control-allow-credentials` = "true", `x-powered-by` = "Flask",
      `x-processed-time` = "0", `content-length` = "89",
      via = "1.1 vegur"
    ), .Names = c(
      "connection", "server",
      "date", "content-type", "location", "access-control-allow-origin",
      "access-control-allow-credentials", "x-powered-by", "x-processed-time",
      "content-length", "via"
    ), class = c("insensitive", "list"))
  ), .Names = c("status", "version", "headers"))), cookies = structure(list(
    domain = logical(0), flag = logical(0), path = logical(0),
    secure = logical(0), expiration = structure(numeric(0), class = c(
      "POSIXct",
      "POSIXt"
    )), name = logical(0), value = logical(0)
  ), .Names = c(
    "domain",
    "flag", "path", "secure", "expiration", "name", "value"
  ), row.names = integer(0), class = "data.frame"),
  content = charToRaw("{\n  \"Content-Type\": \"application/json\", \n  \"Location\": \"http://httpbin.org/status/201\"\n}\n"),
  date = structure(1519431730, class = c("POSIXct", "POSIXt"), tzone = "GMT"), times = structure(c(
    0, 3.1e-05, 3.3e-05,
    7.6e-05, 0.091662, 0.091723
  ), .Names = c(
    "redirect", "namelookup",
    "connect", "pretransfer", "starttransfer", "total"
  ))
), .Names = c(
  "url",
  "status_code", "headers", "all_headers", "cookies", "content",
  "date", "times"
), class = "response")

structure(list(
  url = "http://httpbin.org/html",
  status_code = 200L,
  headers = structure(list(
    connection = "keep-alive",
    server = "meinheld/0.6.1",
    date = "Sat, 27 May 2017 20:08:33 GMT",
    `content-type` = "text/html; charset=utf-8",
    `content-length` = "3741",
    `access-control-allow-origin` = "*",
    `access-control-allow-credentials` = "true",
    `x-powered-by` = "Flask",
    `x-processed-time` = "0.000486850738525",
    via = "1.1 vegur"
  ), class = c("insensitive", "list")),
  all_headers = list(
    structure(list(status = 200L, version = "HTTP/1.1", headers = structure(list(
      connection = "keep-alive", server = "meinheld/0.6.1",
      date = "Sat, 27 May 2017 20:08:33 GMT", `content-type` = "text/html; charset=utf-8",
      `content-length` = "3741", `access-control-allow-origin` = "*",
      `access-control-allow-credentials` = "true", `x-powered-by` = "Flask",
      `x-processed-time` = "0.000486850738525", via = "1.1 vegur"
    ), .Names = c(
      "connection",
      "server", "date", "content-type", "content-length", "access-control-allow-origin",
      "access-control-allow-credentials", "x-powered-by", "x-processed-time",
      "via"
    ), class = c("insensitive", "list"))), .Names = c(
      "status",
      "version", "headers"
    ))
  ),
  content = charToRaw("<!DOCTYPE html>
<html>
  <head>
    </head>
      <body>
        <h1>Herman Melville - Moby-Dick</h1>
            <div>
                <p>Availing himself of the mild, summer-cool weather that now reigned in these latitudes, and in preparation for the peculiarly active pursuits shortly to be anticipated, Perth, the begrimed, blistered old blacksmith, had not removed his portable forge to the hold again, after concluding his contributory work for Ahab's leg, but still retained it on deck, fast lashed to ringbolts by the foremast; being now almost incessantly invoked by the headsmen, and harpooneers, and bowsmen to do some little job for them; altering, or repairing, or new shaping their various weapons and boat furniture. Often he would be surrounded by an eager circle, all waiting to be served; holding boat-spades, pike-heads, harpoons, and lances, and jealously watching his every sooty movement, as he toiled. Nevertheless, this old man's was a patient hammer wielded by a patient arm. No murmur, no impatience, no petulance did come from him. Silent, slow, and solemn; bowing over still further his chronically broken back, he toiled away, as if toil were life itself, and the heavy beating of his hammer the heavy beating of his heart. And so it was.—Most miserable! A peculiar walk in this old man, a certain slight but painful appearing yawing in his gait, had at an early period of the voyage excited the curiosity of the mariners. And to the importunity of their persisted questionings he had finally given in; and so it came to pass that every one now knew the shameful story of his wretched fate. Belated, and not innocently, one bitter winter's midnight, on the road running between two country towns, the blacksmith half-stupidly felt the deadly numbness stealing over him, and sought refuge in a leaning, dilapidated barn. The issue was, the loss of the extremities of both feet. Out of this revelation, part by part, at last came out the four acts of the gladness, and the one long, and as yet uncatastrophied fifth act of the grief of his life's drama. He was an old man, who, at the age of nearly sixty, had postponedly encountered that thing in sorrow's technicals called ruin. He had been an artisan of famed excellence, and with plenty to do; owned a house and garden; embraced a youthful, daughter-like, loving wife, and three blithe, ruddy children; every Sunday went to a cheerful-looking church, planted in a grove. But one night, under cover of darkness, and further concealed in a most cunning disguisement, a desperate burglar slid into his happy home, and robbed them all of everything. And darker yet to tell, the blacksmith himself did ignorantly conduct this burglar into his family's heart. It was the Bottle Conjuror! Upon the opening of that fatal cork, forth flew the fiend, and shrivelled up his home. Now, for prudent, most wise, and economic reasons, the blacksmith's shop was in the basement of his dwelling, but with a separate entrance to it; so that always had the young and loving healthy wife listened with no unhappy nervousness, but with vigorous pleasure, to the stout ringing of her young-armed old husband's hammer; whose reverberations, muffled by passing through the floors and walls, came up to her, not unsweetly, in her nursery; and so, to stout Labor's iron lullaby, the blacksmith's infants were rocked to slumber. Oh, woe on woe! Oh, Death, why canst thou not sometimes be timely? Hadst thou taken this old blacksmith to thyself ere his full ruin came upon him, then had the young widow had a delicious grief, and her orphans a truly venerable, legendary sire to dream of in their after years; and all of them a care-killing competency.
                </p>
          </div>
  </body>
</html>"),
  date = structure(1495915713, class = c("POSIXct", "POSIXt"), tzone = "GMT"),
  times = structure(c(0, 0.018544, 0.100954, 0.101057, 0.186309, 0.186663),
    .Names = c(
      "redirect", "namelookup", "connect", "pretransfer",
      "starttransfer", "total"
    )
  ),
  request = structure(list(
    method = "GET",
    url = "http://httpbin.org/html",
    headers = structure("application/json, text/xml, application/xml, */*",
      .Names = "Accept"
    ),
    fields = NULL,
    options = structure(list(
      useragent = "libcurl/7.51.0 r-curl/2.3 httr/1.2.1",
      httpget = TRUE
    )),
    auth_token = NULL,
    output = structure(list(), class = c("write_memory", "write_function"))
  ),
  class = "request"
  )
),
class = "response"
)

public({
  test_that("Outside of without_internet, requests work", {
    skip_if_disconnected()
    skip_on_ci()
    expect_error(GET("http://httpbin.org/get"), NA)
  })
  test_that("without_internet throws errors on GET", {
    without_internet({
      expect_error(
        GET("http://httpbin.org/get"),
        "GET http://httpbin.org/get"
      )
      expect_GET(
        GET("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
    })
  })

  without_internet({
    test_that("without_internet throws error on other verbs", {
      expect_PUT(
        PUT("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_POST(
        POST("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_PATCH(
        PATCH("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_DELETE(
        DELETE("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
    })

    test_that("without_internet includes request body in message", {
      expect_PUT(
        PUT("http://httpbin.org/get", body = '{"test":true}'),
        "http://httpbin.org/get",
        '{"test":true}'
      )
      expect_POST(
        POST("http://httpbin.org/get", body = '{"test":true}'),
        "http://httpbin.org/get",
        '{"test":true}'
      )
      expect_PATCH(
        PATCH("http://httpbin.org/get", body = '{"test":true}'),
        "http://httpbin.org/get",
        '{"test":true}'
      )
      b2 <- "http://httpbin.org/post"
      expect_POST(
        POST(b2, body = list(x = "A simple text string")),
        "http://httpbin.org/post",
        'list(x = "A simple text string")'
      )
    })

    test_that("max.print option", {
      options(httptest.max.print = 3)
      on.exit(options(httptest.max.print = NULL))
      expect_PUT(
        PUT("http://httpbin.org/get", body = '{"test":true}'),
        "http://httpbin.org/get",
        '{"t'
      )
      # Just to be explicit since the expectations do partial matching
      skip_if(third_edition)
      expect_failure(
        expect_PUT(
          PUT("http://httpbin.org/get", body = '{"test":true}'),
          "http://httpbin.org/get",
          '{"test":true}'
        )
      )
    })

    test_that("without_internet respects query params", {
      expect_GET(
        GET("http://httpbin.org/get",
          query = list(test = "a phrase", two = 3)
        ),
        "http://httpbin.org/get?test=a%20phrase&two=3"
      )
    })

    test_that("expect_no_request", {
      expect_no_request(rnorm(5))
      expect_failure(expect_no_request(GET("http://httpbin.org/get")))
    })
  })
})

public({
  test_that("safe_untrace makes mocking not error if not already traced", {
    expect_error(use_mock_api(), NA)
    expect_error(stop_mocking(), NA)
    expect_error(stop_mocking(), NA)
  })

  test_that("safe_untrace makes recording not error if not already traced", {
    expect_error(start_capturing(), NA)
    expect_error(stop_capturing(), NA)
    expect_error(stop_capturing(), NA)
  })

  FUNS <- list(
    httr = c('request_perform', 'body_config'),
    curl = c('form_file')
  )
  
  .are_pkgs_traced <- function() {
    .process_fun <- function(fun, pkg) {
      inherits(getFromNamespace(fun, pkg), "functionWithTrace")
    }
    .process_pkg <- function(pkg) {
      sapply(FUNS[[pkg]], .process_fun, pkg = pkg)
    }
    unlist(lapply(names(FUNS), .process_pkg))
  }

  with_mock_api({
    test_that("curl/httr functions are properly traced", {
      expect_true(all(.are_pkgs_traced()))
    })
  })

  test_that("curl/httr functions are properly untraced", {
      expect_false(any(.are_pkgs_traced()))
  })

})

test_that("quietly muffles messages, conditional on httptest.debug", {
  expect_message(quietly(message("A message!")), NA)
  options(httptest.debug = TRUE)
  on.exit(options(httptest.debug = NULL))
  expect_message(quietly(message("A message!")), "A message!")
})

public({
  with_fake_http({
    test_that("fakeGET", {
      expect_message(
        g <- GET("http://httpbin.org/get"),
        "GET http://httpbin.org/get"
      )
      expect_null(content(g))
      expect_identical(g$url, "http://httpbin.org/get")
    })
    test_that("expect_GET with/without omitted url", {
      expect_GET(
        GET("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_GET(GET("http://httpbin.org/get"))
    })
    test_that("fakeGET with query", {
      expect_GET(
        g <- GET("http://httpbin.org/get", query = list(a = 1)),
        "http://httpbin.org/get?a=1"
      )
      expect_null(content(g))
      expect_identical(g$url, "http://httpbin.org/get?a=1")
    })
    test_that("fakePUT", {
      expect_PUT(
        p <- PUT("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_null(content(p))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("fakePUT with body", {
      expect_PUT(
        p <- PUT("http://httpbin.org/get", body = '{"b":2}'),
        "http://httpbin.org/get"
      )
      expect_equal(content(p), list(b = 2))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("expect_PUT with/without omitted url", {
      expect_PUT(
        PUT("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_PUT(PUT("http://httpbin.org/get"))
    })
    test_that("fakePATCH", {
      expect_PATCH(
        p <- PATCH("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_null(content(p))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("fakePATCH with body", {
      expect_PATCH(
        p <- PATCH("http://httpbin.org/get", body = '{"b":2}'),
        "http://httpbin.org/get"
      )
      expect_equal(content(p), list(b = 2))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("expect_PATCH with/without omitted url", {
      expect_PATCH(
        PATCH("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_PATCH(PATCH("http://httpbin.org/get"))
    })
    test_that("fakePOST", {
      expect_POST(
        p <- POST("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_null(content(p))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("fakePOST with body", {
      expect_POST(
        p <- POST("http://httpbin.org/get", body = '{"b":2}'),
        "http://httpbin.org/get"
      )
      expect_equal(content(p), list(b = 2))
      expect_identical(p$url, "http://httpbin.org/get")
    })
    test_that("expect_POST with/without omitted url", {
      expect_POST(
        POST("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_POST(POST("http://httpbin.org/get"))
    })
    test_that("fakeDELETE", {
      expect_DELETE(
        d <- DELETE("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_null(content(d))
      expect_identical(d$url, "http://httpbin.org/get")
    })
    test_that("expect_DELETE with/without omitted url", {
      expect_DELETE(
        DELETE("http://httpbin.org/get"),
        "http://httpbin.org/get"
      )
      expect_DELETE(DELETE("http://httpbin.org/get"))
    })
  })
})

test_that("fake_response returns a valid enough response even if you give it just a URL", {
  expect_s3_class(fake_response("http://httpbin.org/get"), "response")
})

test_that("fake_request gets covered directly (not just in tracer)", {
  expect_message(
    expect_s3_class(
      fake_request(list(method = "GET", url = "http://httpbin.org/get")),
      "response"
    ),
    "GET http://httpbin.org/get"
  )
  expect_message(
    expect_s3_class(
      fake_request(
        list(
          method = "POST",
          url = "http://httpbin.org/get",
          options = list(postfields = charToRaw("body"))
        )
      ),
      "response"
    ),
    "POST http://httpbin.org/get body"
  )
})

test_that("currently_offline interacts with the mock contexts", {
  expect_message(
    expect_false(with_fake_http(currently_offline())),
    "GET http://httpbin.org/"
  )
  expect_true(without_internet(currently_offline()))
})

public({
  test_that("skip_if_disconnected when disconnected", {
    without_internet({
      skip_if_disconnected("This should skip")
      expect_true(FALSE)
    })
  })
  test_that("skip_if_disconnected when 'connected'", {
    expect_message(
      with_fake_http({
        skip_if_disconnected("This should not skip")
        expect_failure(expect_true(FALSE))
      }),
      "GET http://httpbin.org/"
    )
  })
})

test_that("Functions not exported can be found", {
  expect_true(.internalFunction())
})

public({
  test_that("If a function is not exported, the public test context errors", {
    skip_if(pkgload::is_dev_package("httptest")) # load_all puts everything in the global env
    expect_error(
      .internalFunction(),
      'could not find function ".internalFunction"'
    )
  })
})

test_that("json_compare", {
  obj <- list(c = 1, b = list(list(2, 3), list(d = 9, f = 5)), a = 5)
  expect_false(json_compare(list(1, 2), list(2, 1))$equal)
  expect_false(json_compare(
    obj,
    list(c = 1, b = list(list(3, 2), list(d = 9, f = 5)), a = 5)
  )$equal)
  expect_false(json_compare(
    obj,
    list(c = 1, b = list(list(d = 9, f = 5), list(2, 3)), a = 5)
  )$equal)
})

public({
  test_that("JSON equivalence", {
    obj <- list(c = 1, b = list(list(2, 3), list(d = 9, f = 5)), a = 5)
    expect_json_equivalent(4, 4)
    expect_json_equivalent(
      list(n = 5, q = list(r = 55, p = 9)),
      list(q = list(p = 9, r = 55), n = 5)
    )
    expect_json_equivalent(list(1, 2), list(1, 2))
    expect_json_equivalent(
      list(b = list(list(2, 3), list(f = 5, d = 9)), c = 1, a = 5),
      obj
    )
  })
})

public({
  with_mock_api({
    test_that("Can load an object and file extension is added", {
      a <- GET("api/")
      expect_identical(content(a), list(value = "api/object1/"))
      b <- GET(content(a)$value)
      expect_identical(content(b), list(object = TRUE))
    })
    test_that("GET with query", {
      obj <- GET("api/object1/", query = list(a = 1))
      expect_json_equivalent(
        content(obj),
        list(query = list(a = 1), mocked = "yes")
      )
    })
    test_that("GET with special characters", {
      a <- GET("api/x(y='1',z='2')")
      expect_identical(content(a), list(object = TRUE))
    })
    test_that("GET files that don't exist errors", {
      expect_GET(GET("api/NOTAFILE/"), "api/NOTAFILE/")
      expect_GET(
        GET("api/NOTAFILE/", query = list(a = 1)),
        "api/NOTAFILE/?a=1"
      )
    })
    test_that("POST method reads from correct file", {
      b <- POST("api/object1")
      expect_identical(content(b), list(method = "POST"))
      b2 <- POST("api/object1",
        body = "", content_type_json(),
        add_headers(
          Accept = "application/json",
          "Content-Type" = "application/json"
        )
      )
      expect_identical(content(b2), list(method = "POST"))
    })
    test_that("Request body is appended to mock file path", {
      p <- POST("api/object1",
        body = '{"a":1}', content_type_json(),
        add_headers(
          Accept = "application/json",
          "Content-Type" = "application/json"
        )
      )
      expect_identical(content(p), list(content = TRUE))
      expect_POST(
        POST("api/object1",
          body = '{"b":2}', content_type_json(),
          add_headers(
            Accept = "application/json",
            "Content-Type" = "application/json"
          )
        ),
        'api/object1 {"b":2} (api/object1-3e8d9a-POST.json)'
      )
    })
    test_that("max.print option", {
      options(httptest.max.print = 3)
      on.exit(options(httptest.max.print = NULL))
      expect_PUT(
        PUT("http://httpbin.org/get", body = '{"test":true}'),
        "http://httpbin.org/get",
        '{"t ',
        "(httpbin.org/get-"
      )
    })
    test_that("Request body and query", {
      expect_PATCH(
        PATCH("api/object2?d=1", body = '{"arg":45}'),
        'api/object2?d=1 {"arg":45} (api/object2-899b0e-3d8d62-PATCH.json)'
      )
    })
    test_that("Other verbs error too", {
      expect_PUT(PUT("api/"), "api/")
      expect_PATCH(PATCH("api/"), "api/")
      expect_POST(POST("api/"), "api/")
      expect_POST(
        POST("api/", body = '{"arg":true}'),
        "api/",
        '{"arg":true}'
      )
      expect_DELETE(DELETE("api/"), "api/")
    })

    test_that("mock API with http:// URL, not file path", {
      expect_GET(
        GET("http://httpbin.org/get"),
        "http://httpbin.org/get",
        "(httpbin.org/get.json)"
      )
      expect_GET(
        GET("https://httpbin.org/get"),
        "https://httpbin.org/get",
        "(httpbin.org/get.json)"
      )
      expect_identical(
        content(GET("http://example.com/get")),
        list(loaded = TRUE)
      )
    })

    test_that("Mocking a GET with more function args (path, auth)", {
      expect_identical(
        content(GET("http://example.com",
          path = "/get",
          add_headers("Content-Type" = "application/json"),
          authenticate("d", "d")
        )),
        list(loaded = TRUE)
      )
    })

    test_that("Mock GET with non-JSON", {
      dick <- GET("http://example.com/html")
      expect_true(grepl("Melville", content(dick, "text")))
    })

    test_that("POST/PUT/etc. with other body types", {
      b2 <- "http://httpbin.org/post"
      expect_POST(
        POST(b2, body = list(x = "A simple text string")),
        "http://httpbin.org/post",
        'list(x = "A simple text string") ',
        "(httpbin.org/post-97fc23-POST.json)"
      )
      expect_POST(
        POST(b2, body = list(x = "A simple text string"), encode = "form"),
        "http://httpbin.org/post",
        "x=A%20simple%20text%20string ",
        "(httpbin.org/post-aa2999-POST.json)"
      )
      expect_PUT(
        PUT(b2, body = list(x = "A simple text string")),
        "http://httpbin.org/post",
        'list(x = "A simple text string") ',
        "(httpbin.org/post-97fc23-PUT.json)"
      )
      expect_POST(
        POST(b2, body = list(x = "A simple text string"), encode = "json"),
        "http://httpbin.org/post",
        '{"x":"A simple text string"} ',
        "(httpbin.org/post-34199a-POST.json)"
      )
      expect_POST(
        POST(b2, body = list(y = upload_file(testthat::test_path("setup.R")))),
        "http://httpbin.org/post",
        'list(y = list(path = "',
        testthat::test_path("setup.R"),
        '", type = "text/plain", name = NULL)) ',
        "(httpbin.org/post-83f219-POST.json)"
      )
    })

    test_that("PUT/POST with only a upload_file in body", {
      b1 <- "http://httpbin.org/post"
      expect_POST(
        POST(b1, body = upload_file(testthat::test_path("setup.R"))),
        "http://httpbin.org/post",
        "(httpbin.org/post-POST.json)"
      )
      # and ensure that there are no floating connections still open
      open_conns <- showConnections()
      expect_false(any(open_conns[, "description"] == "setup.R"))
      b2 <- "http://httpbin.org/put"
      expect_PUT(
        PUT(b2, body = upload_file(testthat::test_path("setup.R"))),
        "http://httpbin.org/put",
        "(httpbin.org/put-PUT.json)"
      )
      # and ensure that there are no floating connections still open
      open_conns <- showConnections()
      expect_false(any(open_conns[, "description"] == "setup.R"))
    })

    test_that("Regular expressions in expect_VERB", {
      expect_GET(GET("http://example.com/1234/abcd/"),
        "http://example.com/[0-9]{4}/[a-z]{4}/",
        fixed = FALSE
      )
      expect_GET(GET("http://example.com/1234/abcd/"),
        "http://EXAMPLE.com/[0-9]{4}/[a-z]{4}/",
        fixed = FALSE,
        ignore.case = TRUE
      )
      expect_POST(POST("http://example.com/1234/abcd/"),
        "http://example.com/[0-9]{4}/[a-z]{4}/",
        fixed = FALSE
      )
      expect_DELETE(DELETE("http://example.com/1234/abcd/"),
        "http://example.com/[0-9]{4}/[a-z]{4}/",
        fixed = FALSE
      )
    })

    test_that("Returned (JSON) mock response contains the actual request", {
      a <- GET("api/", add_headers(`X-FakeHeader` = "fake_value"))
      expect_true("X-FakeHeader" %in% names(a$request$headers))
    })

    test_that("Request preprocessing via set_requester: change the request URL", {
      g1 <- GET("http://example.com/get")
      old <- getOption("httptest.requester")
      on.exit(options(httptest.requester = old))
      set_requester(function(request) {
        gsub_request(request, "pythong.org", "example.com")
      })
      expect_identical(
        content(GET("http://pythong.org/get")),
        content(g1)
      )
    })
  })

})

test_that("build_mock_url file path construction with character URL", {
  # GET (default) method
  file <- build_mock_url("http://www.test.com/api/call")
  expect <- "www.test.com/api/call"
  expect_identical(file, expect, label = "Get method without query string")

  # GET method with query in URL
  file <- build_mock_url("http://www.test.com/api/call?q=1")
  expect <- "www.test.com/api/call-a3679d"
  expect_identical(file, expect, label = "Get method with query string")

  # POST method
  file <- build_mock_url("http://www.test.com/api/call", method = "POST")
  expect <- "www.test.com/api/call-POST"
  expect_identical(file, expect, "POST method without query string")

  # POST method with query in URL
  file <- build_mock_url("http://www.test.com/api/call?q=1", method = "POST")
  expect <- "www.test.com/api/call-a3679d-POST"
  expect_identical(file, expect, "POST method with query string")
})

test_that("build_mock_url returns file names that are valid on all R platforms", {
  u <- "https://language.googleapis.com/v1/documents:annotateText/"
  expect_identical(
    build_mock_url(u),
    "language.googleapis.com/v1/documents-annotateText"
  )
})

test_that("load_response invalid extension handling", {
  expect_error(
    load_response("foo.qwert"),
    "Unsupported mock file extension: qwert"
  )
})

test_that("mock_request code paths are covered (outside of trace)", {
  expect_s3_class(
    mock_request(list(method = "GET", url = "api/")),
    "response"
  )
  expect_s3_class(
    mock_request(list(method = "GET", url = "http://example.com/html")),
    "response"
  )
  expect_error(mock_request(list(method = "PUT", url = "api/")))
})

public({
  with_fake_http({
    test_that("expect_header with fake HTTP", {
      expect_GET(expect_success(expect_header(
        GET("http://httpbin.org/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "Accept: image/jpeg"
      )))
      expect_GET(expect_failure(expect_warning(
        expect_header(
          GET("http://httpbin.org/",
            config = add_headers(Accept = "image/png")
          ),
          "Accept: image/jpeg"
        ),
        "Accept: image/png"
      )))
      expect_POST(expect_success(expect_header(
        POST("http://httpbin.org/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "Accept: image/jpeg"
      )))
      expect_POST(expect_failure(expect_warning(
        expect_header(
          POST("http://httpbin.org/",
            config = add_headers(Accept = "image/png")
          ),
          "Accept: image/jpeg"
        ),
        "Content-Type: Accept: image/png"
      )))
    })
  })

  with_mock_api({
    test_that("expect_header with mock API", {
      expect_success(expect_header(
        GET("api/object1/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "Accept: image/jpeg"
      ))
      suppressWarnings(
        expect_failure(expect_header(
          GET("api/object1/",
            config = add_headers(Accept = "image/png")
          ),
          "Accept: image/jpeg"
        ))
      )
      suppressWarnings(
        expect_POST(expect_success(expect_header(
          POST("http://httpbin.org/",
            config = add_headers(Accept = "image/jpeg")
          ),
          "Accept: image/jpeg"
        )))
      )
      skip_if(third_edition)
      expect_failure(expect_header(
        expect_POST(POST("http://httpbin.org/",
          config = add_headers(Accept = "image/png")
        ), silent = TRUE),
        "Accept: image/jpeg"
      ))
    })
    test_that("expect_header ignore.case", {
      expect_success(expect_header(
        GET("api/object1/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "accept: image/jpeg"
      ))
      suppressWarnings(
        expect_failure(expect_header(GET("api/object1/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "accept: image/jpeg",
        ignore.case = FALSE
        ))
      )
    })
  })

  without_internet({
    test_that("expect_header without_internet", {
      expect_GET(expect_success(expect_header(
        GET("http://httpbin.org/",
          config = add_headers(Accept = "image/jpeg")
        ),
        "Accept: image/jpeg"
      )))
      expect_GET(expect_warning(
        expect_failure(expect_header(
          GET("http://httpbin.org/",
            config = add_headers(Accept = "image/png")
          ),
          "Accept: image/jpeg"
        )),
        "Accept: image/png"
      ))
    })
  })

  test_that("expect_header works with actual network too", {
    skip_if_disconnected()
    skip_on_ci()
    expect_success(expect_header(
      GET("http://httpbin.org/get",
        config = add_headers(Accept = "image/jpeg")
      ),
      "Accept: image/jpeg"
    ))
    expect_failure(expect_warning(
      expect_header(
        GET("http://httpbin.org/get",
          config = add_headers(Accept = "image/png")
        ),
        "Accept: image/jpeg"
      ),
      "Accept: image/png"
    ))
  })
})

resp <- source("example.com/html.R")$value

test_that("get_content_type handles valid Content-Types, including omitted", {
  expect_identical(resp$headers[["content-type"]], "text/html; charset=utf-8")
  expect_identical(get_content_type(resp), "text/html")
  resp$headers[["content-type"]] <- "application/json"
  expect_identical(get_content_type(resp), "application/json")
  resp$headers[["content-type"]] <- NULL
  expect_identical(get_content_type(resp), "")
})
